; CMEM32.ASM
; Fr Comp3D
; Assemblieren: Tasm cmem32 -zi -ml

.MODEL large
.386
LOCALS ; enable local labels


.CODE


ALIGN 16

; BOOL _scandw (long **Start, long *MaxCnt, long *Index, long Value);
;
; <-  Start : Zeiger auf 1. zu durchsuchendes Element
;  -> Start : Zeigt auf das nchste Element
;             ACHTUNG: wrap around bei Segmentgrenzen !
; <-  MaxCnt: Anzahl der max. zu untersuchenden Elemente (longs)
;  -> MaxCnt: Verbleibende Elemente
;  -> Index : Index des gefundenen Elements
; <-  Value : gesuchter Wert
; RETURN VALUE: TRUE, wenn gefunden
;

          PUBLIC _scandw

_scandw PROC FAR

          push  bp                     ; Stack frame
          mov   bp,sp

          pushad

          les   bx, dword ptr [bp+10]  ; ecx = *MaxCnt
          mov   ecx, dword ptr es:[bx]
          jecxz @@notfound

          mov   eax, dword ptr [bp+18] ; eax = Value

          les   bx,dword ptr [bp+6]    ; es:edi = *Start
          xor   edi,edi
          mov   di,word ptr es:[bx]
          mov   es,word ptr es:[bx+2]

          cld

          db 067h                      ; 32-bit Prefix
          repne
          scasd

          je    @@found

@@notfound:

          mov   ax,es
          les   bx,dword ptr [bp+6]    ; *Start = es:di (NICHT es:edi) !!
          mov   word ptr es:[bx], di
          mov   word ptr es:[bx+2], ax

          les   bx, dword ptr [bp+10]  ; *Index = *MaxCnt
          mov   eax, dword ptr es:[bx] ;   eax = *MaxCnt
          les   bx, dword ptr [bp+14]
          mov   dword ptr es:[bx],eax  ;   *Index = eax

          les   bx, dword ptr [bp+10]  ; *MaxCnt = 0
          mov   dword ptr es:[bx],0


          mov   ax, 0;                 ; return FALSE
          jmp   @@done

@@found:

          mov   ax,es
          les   bx,dword ptr [bp+6]    ; *Start = es:di (NICHT es:edi) !!
          mov   word ptr es:[bx], di
          mov   word ptr es:[bx+2], ax

          les   bx, dword ptr [bp+10]  ; *Index = *MaxCnt - ecx
          mov   eax, dword ptr es:[bx] ;   eax=*MaxCnt
          les   bx, dword ptr [bp+14]
          mov   dword ptr es:[bx],eax  ;   *Index = eax
          sub   dword ptr es:[bx],ecx  ;   *Index = *Index - ecx

          les   bx, dword ptr [bp+10]  ; *MaxCnt = ecx
          mov   dword ptr es:[bx],ecx

          mov   ax, 1;                 ; return TRUE
@@done:
          push  ax
          popad
          pop   ax

          pop   bp
          ret

_scandw ENDP

; BOOL _scanFaceArray (FACE_S **Start, long *nElem,
;                      long *FoundIdx, long Value);
;
; <-  Start : Zeiger auf 1. zu durchsuchendes Element
;  -> Start : Zeigt auf das nchste Element
;             ACHTUNG: wrap around bei Segmentgrenzen !
; <-  nElem: Anzahl der max. zu untersuchenden Elemente (longs)
;  -> nElem: Verbleibende Elemente
;  -> FoundIdx : Index des gefundenen Elements
; <-  Value : gesuchter Wert
; RETURN VALUE: TRUE, wenn gefunden
;

          PUBLIC _scanFaceArray

_scanFaceArray PROC FAR

          push  bp                     ; Stack frame
          mov   bp,sp

          pushad

          les   bx, dword ptr [bp+10]  ; ecx = *nElem
          mov   ecx, dword ptr es:[bx]
          jecxz @@notfound

          mov   eax, dword ptr [bp+18] ; eax = Value

          les   bx,dword ptr [bp+6]    ; es:edi = *Start
          xor   edi,edi
          mov   di,word ptr es:[bx]
          mov   es,word ptr es:[bx+2]

          ALIGN 16                     ; Alignment

@@loop:
          cmp   es:[edi],eax           ; eax==Index[0] ?
          je    @@found
          cmp   es:[edi+4],eax         ; eax==Index[1] ?
          je    @@found
          cmp   es:[edi+8],eax         ; eax==Index[2] ?
          je    @@found
          add   edi,20                 ; N, MaxN, HVP berspringen
          loopd @@loop

@@notfound:

          mov   ax,es
          les   bx,dword ptr [bp+6]    ; *Start = es:di (NICHT es:edi) !!
          mov   word ptr es:[bx], di
          mov   word ptr es:[bx+2], ax

          les   bx, dword ptr [bp+10]  ; *FoundIdx += *nElem
          mov   eax, dword ptr es:[bx] ;   eax = *nElem
          les   bx, dword ptr [bp+14]
          add   dword ptr es:[bx],eax  ;   *FoundIdx += eax

          les   bx, dword ptr [bp+10]  ; *nElem = 0
          mov   dword ptr es:[bx],0


          popad
          mov   ax, 0;                 ; return FALSE
          jmp   @@done

@@found:
          add   edi,20
          dec   ecx

          mov   ax,es
          les   bx,dword ptr [bp+6]    ; *Start = es:di (NICHT es:edi) !!
          mov   word ptr es:[bx], di
          mov   word ptr es:[bx+2], ax

          les   bx, dword ptr [bp+10]  ; *FoundIdx += *nElem - ecx
          mov   eax, dword ptr es:[bx] ; eax=*nElem
          les   bx, dword ptr [bp+14]
          add   dword ptr es:[bx],eax  ;   *FoundIdx += eax
          sub   dword ptr es:[bx],ecx  ;   *FoundIdx -= ecx

          les   bx, dword ptr [bp+10]  ; *nElem = ecx
          mov   dword ptr es:[bx],ecx

          popad
          mov   ax, 1;                 ; return TRUE
@@done:

          pop   bp
          ret

_scanFaceArray ENDP


CODE ENDS
END

