#ifndef CFILEBOX_HPP
  #define CFILEBOX_HPP

/**************************************************************************
*                                                                         *
* Name   : cFileBox.hpp              ( Implementation:                )   *
*                                                                         *
* Klasse(n) definiert :  FILEBOX_C                                        *
* Objekt(e) deklariert:  -                                                *
* Abgeleitet von      :  -                                                *
*                                                                         *
* Aufgabe : Dialogboxen zum Einlesen von Dateinamen.                      *
*           Benutzt COMMDLG.DLL !                                         *
*           Nach dem Aufruf sind Drive, Path, Name, Ext verfgbar.        *
*                                                                         *
*                                                                         *
**************************************************************************/

// --- Includes: ------------------------------------------------------

// --- externe Klassen: -----------------------------------------------

// --- globale Konstanten: --------------------------------------------

typedef enum {
    FBX_OPENDLG,
    FBX_SAVEDLG
} FILEBOXMODE_E;

// --- globale Typen: -------------------------------------------------

/*------------------------------------------------------------------------+
|                                                                         |
| Klasse : FILEBOX_C                                                      |
|                                                                         |
+------------------------------------------------------------------------*/

class FILEBOX_C
{

// --- Variablen: -----------------------------------------------------

private:

protected:

public:
    FILEBOXMODE_E Mode;

    char          Drive    [3];
    char          Name     [13];
    char          Dir      [66];
    char          Ext      [5];

    char          DefExt   [4];        // default extension

    WORD          Flags;               // Dialogbox style flags ( OFN_... )

// --- Methoden -------------------------------------------------------

public:                                // Konstruktor, Destruktor
    FILEBOX_C();
    virtual ~FILEBOX_C();

private:

protected:
    BOOL  fileDlg          (HWND hCaller,
                            char *lpszHeader,
                            char anFSpec[], int FSpecSize,
                            char *lpszFilter[], DWORD &CurrentFilter,
                            char *lpszDefExt);


public:

    void  FSpecToFName     (char *lpszFSpec, char *lpszFName);
    BOOL  fileExist        (char *lpszFSpec);

    /*--------------------------------------------------------------+
    |                                                               |
    | hCaller    = NULL -> no parent window                         |
    | lpszHeader = NULL -> Header="OPEN"                            |
    | FSpec[0]   = \0   -> no initial file name                     |
    | lpszFilter = NULL -> no list of predefined masks              |
    | CurrentFilter: static variable to keep last filter selection  |
    | lpszDefExt = NULL -> no default extension                     |
    |                                                               |
    +---------------------------------------------------------------*/

    BOOL  openFileDlg         (HWND hCaller,
                               char *lpszHeader,
                               char FSpec[], int FSpecSize,
                               char *lpszFilter[], DWORD &CurrentFilter,
                               char *lpszDefExt);

    BOOL  openExistingFileDlg (HWND hCaller,
                               char *lpszHeader,
                               char FSpec[], int FSpecSize,
                               char *lpszFilter[], DWORD &CurrentFilter,
                               char *lpszDefExt);

    BOOL  saveFileDlg         (HWND hCaller,
                               char *lpszHeader,
                               char FSpec[], int FSpecSize,
                               char *lpszFilter[], DWORD &CurrentFilter,
                               char *lpszDefExt);

}; // class FILEBOX_C

#endif CFILEBOX_HPP
