#ifndef CGEOMOUT_C
  #define CGEOMOUT_C

/**************************************************************************
*                                                                         *
* Name   :                           ( Implementation:                )   *
*                                                                         *
* Klasse(n) definiert :  GEOMETRYOUT_C                                    *
* Objekt(e) deklariert:                                                   *
*                                                                         *
* Abgeleitet von      :                                                   *
*                                                                         *
* Aufgabe :                                                               *
*                                                                         *
**************************************************************************/

// --- Includes: ------------------------------------------------------

#include <stdio.h>

// --- externe Klassen: -----------------------------------------------

class TRISET_C;

// --- globale Konstanten: --------------------------------------------

// --- globale Typen: -------------------------------------------------

/*------------------------------------------------------------------------+
|                                                                         |
| Klasse : GEOMETRYOUT_C                                                  |
|                                                                         |
+------------------------------------------------------------------------*/

class GEOMETRYOUT_C
{

// --- Variablen: -----------------------------------------------------

private:

protected:
    int       FlushCnt;
    char      LayerName[20];
    char      NameBody[20];


public:
    FILE      *Zof;
    BOOL      Small;

// --- Methoden -------------------------------------------------------

public:                                // Konstruktor, Destruktor
    GEOMETRYOUT_C();
    virtual ~GEOMETRYOUT_C();

private:

protected:

    // ZOF-Format:

    BOOL   writePoint3      (Ppoint3 &P);
    BOOL   writePt3UV       (Ppoint3 &P, Pfloat U, Pfloat V);
    BOOL   writePtCo3       (Pptco3 &V);

    BOOL   openPattern      (char* aPatternName);
    BOOL   closePattern();
    BOOL   openGroup        (char* aGroupName);
    BOOL   closeGroup();
    BOOL   writeObject      (char* anObectName, char* aPatternName);

    BOOL   writeHeaderZof   (TRISET_C *TP);
    BOOL   flushZof         (TRISET_C *TP);
    BOOL   writeFooterZof   (TRISET_C *TP);

    // DXF-Format:

    BOOL   writePoint3Dxf   (Ppoint3 &P);
    BOOL   writeFaceDxf     (long I1, long I2, long I3);
    BOOL   writeHeaderDxf   (TRISET_C *TP);
    BOOL   flushDxf         (TRISET_C *TP);
    BOOL   writeFooterDxf   (TRISET_C *TP);

    // Allgemein:

    BOOL   writeHeader      (TRISET_C *TP);
    BOOL   flush            (TRISET_C *TP);
    BOOL   writeFooter      (TRISET_C *TP);

public:
    BOOL   isOpen()     { return Zof!=NULL; }

    BOOL   open             (char* aFName, BOOL aSmall);
    void   close();

    BOOL   writeTriset      (TRISET_C *TP);

}; // class GEOMETRYOUT_C

#endif CGEOMOUT_C
