#ifndef CHISTWIN_HPP
  #define CHISTWIN_HPP

/**************************************************************************
*                                                                         *
* Name   : cHistWin.hpp              ( Implementation:                )   *
*                                                                         *
* Klasse(n) definiert :  HISTORYWINDOW_C                                  *
* Objekt(e) deklariert:  -                                                *
* Abgeleitet von      :  -                                                *
*                                                                         *
* Aufgabe :                                                               *
*                                                                         *
**************************************************************************/

// --- Includes: ------------------------------------------------------
// --- externe Klassen: -----------------------------------------------
// --- globale Konstanten: --------------------------------------------

#define NHISTORIES         5

// --- globale Typen: -------------------------------------------------

/*------------------------------------------------------------------------+
|                                                                         |
| Klasse : HISTORYWINDOW_C                                                |
|                                                                         |
+------------------------------------------------------------------------*/

class HISTORYWINDOW_C  {

// --- Variablen: -----------------------------------------------------

private:

protected:
    HWND     hWnd;
    HDC      hDC;                       // Window hat 'OwnDC'
    HBRUSH   hBkBrush;
    HPEN     hPen[NHISTORIES];
    HPEN     hAxisPen;

    char     Legend[NHISTORIES][20];

    DWORD    ElapsedTicks;

    int      MaxCnt;
    int      NCnt;
    long     TotalCnt;
    unsigned Filter;

    float    MaxVal;                   // grter Wert
    float    MinVal;                   // kleinster Wert
    float    ScaleH;                   // Normalisiert MaxVal-MinVal auf 1.0

    float    *HistBuffer[NHISTORIES];

public:
    DWORD    UpdateTicks;               // update max. alle .. ms

// --- Methoden -------------------------------------------------------

public:                                // Konstruktor, Destruktor
    HISTORYWINDOW_C (HWND hCaller, int CmdShow, int MaxN);
    virtual ~HISTORYWINDOW_C();

private:

protected:
    int       registerWindow (HANDLE hInstance);
    HWND      createWindow   (HANDLE hInstance, int CmdShow, HWND hParent);

    BOOL      compactVals();

public:
    BOOL      isOpen()             { return (hWnd!=NULL); }
    HWND      getWnd()             { return hWnd; }

    // Message server:

    void      paint          (HWND hWnd);

    // Methoden:

    void      clear();
    void      repaint();
    void      setRangeY      (float Min, float Max);
    BOOL      addHistory     (float F1, float F2, float F3, float F4, float F5);
    BOOL      iconize();
    BOOL      maximize();

}; // class HISTORYWINDOW_C


#endif CHISTWIN_HPP
