#ifndef INIFILE_HPP
  #define INIFILE_HPP

/**************************************************************************
*                                                                         *
* Name   :                           ( Implementation:                )   *
*                                                                         *
* Klasse(n) definiert :  INIFILE_C                                        *
* Objekt(e) deklariert:  -                                                *
* Abgeleitet von      :  -                                                *
*                                                                         *
* Aufgabe : Lesen und schreiben von Windows Ini-Dateien                   *
*                                                                         *
* Include Windows.h first !                                               *
*                                                                         *
**************************************************************************/

// --- Includes: ------------------------------------------------------
// --- globale Konstanten ---------------------------------------------
// --- globale Typen --------------------------------------------------

typedef enum {
    INI_OK        = 0,
    INI_NOTFOUND,
    INI_TYPEERROR
} INIFILESTATUS_E;

/*------------------------------------------------------------------------+
|                                                                         |
| Klasse : INIFILE_C                                                      |
|                                                                         |
+------------------------------------------------------------------------*/

class INIFILE_C {

// --- Variablen: -----------------------------------------------------

private:

protected:
    char            FName [13];
    char            Application [30];
    char            Buffer [256];
    INIFILESTATUS_E Status;

public:

// --- Methoden -------------------------------------------------------

public:                                // Konstruktor, Destruktor
    INIFILE_C (char *anFName);
    virtual ~INIFILE_C();

private:

protected:

public:
    INIFILESTATUS_E status() { return Status; }

    void     setApplicationName (char *aName);

    char*    getString (char *aKeyName, char *aDefault);
    BOOL     getBool   (char *aKeyName, BOOL aDefault);
    int      getInt    (char *aKeyName, int aDefault);
    long     getLong   (char *aKeyName, long aDefault);
    float    getFloat  (char *aKeyName, float aDefault);
    double   getDouble (char *aKeyName, double aDefault);
    POINT    getPoint  (char *aKeyName, POINT  aDefault);
    RECT     getRect   (char *aKeyName, RECT   aDefault);

    BOOL     writeString (char *aKeyName, char* aValue);
    BOOL     writeBoolYN (char *aKeyName, BOOL aValue);    // Yes, No
    BOOL     writeBoolJN (char *aKeyName, BOOL aValue);    // Ja, Nein
    BOOL     writeBoolOO (char *aKeyName, BOOL aValue);    // On, Off
    BOOL     writeBoolTF (char *aKeyName, BOOL aValue);    // True, False
    BOOL     writeInt    (char *aKeyName, int aValue);
    BOOL     writeLong   (char *aKeyName, long aValue);
    BOOL     writeFloat  (char *aKeyName, float aValue, int aDecimals=5);
    BOOL     writeDouble (char *aKeyName, double aValue, int aDecimals=6);
    BOOL     writePoint  (char *aKeyName, POINT *aValue);
    BOOL     writeRect   (char *aKeyName, RECT *aValue);

    BOOL     deleteKey   (char *aKeyName);

}; // class INIFILE_C


#endif INIFILE_HPP
