#ifndef CMAINWND_HPP
  #define CMAINWND_HPP

/**************************************************************************
*                                                                         *
* Name   : cMainWnd.hpp              ( Implementation:                )   *
*                                                                         *
* Klasse(n) definiert :  MAINWINDOW_C                                     *
* Objekt(e) deklariert:  -                                                *
* Abgeleitet von      :  -                                                *
*                                                                         *
* Aufgabe : Comp3D Frame Window, Hauptmen, About-Dialogbox, ...          *
*                                                                         *
**************************************************************************/

// --- Includes: ------------------------------------------------------

// --- externe Klassen: -----------------------------------------------
// --- globale Konstanten: --------------------------------------------

#define VERSIONSTRING     "Comp3D v1.0 beta"
#define COMP3DCLASSNAME   "Comp3dClass"


// --- globale Typen: -------------------------------------------------

// Hauptmen ID's:

typedef enum {

    MAIN_CONVREDUC    = 1010,
    MAIN_EXIT         = 1900,
    MAIN_OPTSINPUT    = 2010,
    MAIN_OPTSFILTER   = 2020,
    MAIN_OPTSREDUCPL  = 2030,
    MAIN_OPTSREDUCTRI = 2040,
    MAIN_OPTSTEXTURE  = 2050,
    MAIN_OPTSOUTPUT   = 2060,
    MAIN_OPTSHISTORY  = 2100,
    MAIN_DBGLOGCEF    = 3010,
    MAIN_DBGLOGSETTNG = 3020,
    MAIN_DBGLOGHISTORY= 3030,
    MAIN_DBGMORE      = 3100,
    MAIN_ABOUT        = 9900
} MAINMENUID_E;

// Hauptmen Poitionen der PopUp Eintrge:

typedef enum {

    MAIN_POS_FILE     =    0,
    MAIN_POS_OPTIONS  =    1,
    MAIN_POS_DEBUG    =    2,
    MAIN_POS_HELP     =    3
} MAINMENUPOS_E;

typedef enum {

    ABOUT_ST_VERSION   = 1000,
    ABOUT_ST_DATE      = 1010

} ABOUTDLGHANDLES_E;


/*------------------------------------------------------------------------+
|                                                                         |
| Klasse : MAINWINDOW_C                                                   |
|                                                                         |
+------------------------------------------------------------------------*/

class MAINWINDOW_C  {

// --- Variablen: -----------------------------------------------------

private:

protected:

public:
    HWND      hWnd;

// --- Methoden -------------------------------------------------------

public:                                // Konstruktor, Destruktor
    MAINWINDOW_C();
    virtual ~MAINWINDOW_C();

private:

protected:
    int       registerWindow (HANDLE hInstance);
    HWND      createWindow   (HANDLE hInstance, int CmdShow);

public:
    int       execAboutDlg   (HWND hCaller);

    int       openWnd        (int CmdShow);
    BOOL      updateMenu();

    int       comp3dMain();

}; // class MAINWINDOW_C


#endif CMAINWND_HPP
