#ifndef CPOLYLIN_HPP
  #define CPOLYLIN_HPP

/**************************************************************************
*                                                                         *
* Name   : cPolyLin.hpp              ( Implementation:                )   *
*                                                                         *
* Klasse(n) definiert :  DYNARRAY_C,                                      *
*                        POLYGON_C                                        *
*                                                                         *
* Objekt(e) deklariert:  -                                                *
* Abgeleitet von      :  -                                                *
*                                                                         *
* Aufgabe :                                                               *
*                                                                         *
*                                                                         *
**************************************************************************/

// --- Includes: ------------------------------------------------------

// --- externe Klassen: -----------------------------------------------

// --- globale Konstanten: --------------------------------------------

// --- globale Typen: -------------------------------------------------

/*------------------------------------------------------------------------+
|                                                                         |
| Klasse : template DYNARRAY_C<Type>                                      |
|                                                                         |
|          Allgemeine Klasse zur Speicherung von Elementen des Typs       |
|          <Type> in einem dynamisch wachsenden Array.                    |
|                                                                         |
|          ACHTUNG: wenn <T> eine Objekt ist, mu der Destruktor          |
|                   explizit aufgerufen werden !                          |
|                                                                         |
+------------------------------------------------------------------------*/

template <class T>

class DYNARRAY_C {

// --- Variablen: -----------------------------------------------------

protected:
    int          N;                    // Anzahl der Elemnte
    int          MaxN;                 // maximale Anzahl von Elementen
    int          GrowBy;               // Anzahl der Elemente, um die das Array
                                       // bei Bereichsberschreitung automatisch
                                       // vergrert wird.

public:
    T            *Val;             // Zeiger auf Array von Elementen

// --- Methoden -------------------------------------------------------

public:                                // Konstruktor, Destruktor
    DYNARRAY_C  (int aMax, int aGrowBy);
    virtual ~DYNARRAY_C();

protected:

public:
    virtual int       nElem()    { return N; }
    virtual int       maxElem()  { return MaxN; }

    virtual BOOL      adjustSize();
    virtual BOOL      newSize        (int nElements);

    virtual BOOL      append         (T &anElement);
    virtual BOOL      insertFirst    (T &anElement);
    virtual BOOL      deleteLast();

    virtual BOOL      deleteBetween  (int A, int B);

    virtual BOOL      copyFrom       (DYNARRAY_C<T> *SourceP);


    virtual void      clear();                 // Array lschen
    virtual void      dump();

}; // class DYNARRAY_C


#define VERTEXARRAY_C DYNARRAY_C<Pptco3>
#define INDEXARRAY_C  DYNARRAY_C<long>


/*------------------------------------------------------------------------+
|                                                                         |
| Klasse : POLYGON_C                                                      |
|          Ringliste von positiven long ints. (Interpretiert als Indizes  |
|          in eine Face-Liste.                                            |
|          Gelschte Eintrge werden negativ dargestellt !                |
|          Die Eintrge werden intern um 1 erhht (damit auch '0' negiert |
|          werden kann).                                                  |
|                                                                         |
+------------------------------------------------------------------------*/

class POLYGON_C
{

// --- Variablen: -----------------------------------------------------

protected:
    int          High;                 // Anzahl aller Vertizes - 1
    int          Max;                  // max. Anzahl aller Vertizes - 1
    long         *VP;                  // Values

public:
    int          N;                    // Anzahl der gltigen Vertizes

// --- Methoden -------------------------------------------------------

public:                                // Konstruktor, Destruktor
    POLYGON_C (int MaxVerts);
    virtual ~POLYGON_C();

protected:

public:
    int       nElem()        { return N; }

    void      add            (long Value);
    void      insertFirst    (long Value);
    void      clear();

    // I: 0..N;  Tag: 0..High

    int  del   (int I);                // returns Tag (-> undel)
    void undel (int Tag);

    long value (int I);
    long prec  (int I);
    long succ  (int I);

}; // class POLYGON_C


#endif CPOLYLIN_HPP
