#ifndef CSTATWIN_HPP
  #define CSTATWIN_HPP

/**************************************************************************
*                                                                         *
* Name   : cStatWin.hpp              ( Implementation:                )   *
*                                                                         *
* Klasse(n) definiert :  STATUSWINDOW_C                                   *
* Objekt(e) deklariert:  -                                                *
* Abgeleitet von      :  -                                                *
*                                                                         *
* Aufgabe :                                                               *
*                                                                         *
**************************************************************************/

// --- Includes: ------------------------------------------------------

#include "cGlobal.hpp"

// --- externe Klassen ------------------------------------------------

class HISTORYWINDOW_C;

// --- globale Konstanten ---------------------------------------------

// --- globale Typen --------------------------------------------------

typedef enum {

    STAT_ST_STATUS     =   10,
    STAT_ST_MEMFREE    = 1000,
    STAT_ST_MAXFREE    = 1010,
    STAT_ST_DISKFREE   = 1020,
    STAT_BM_BAR        = 1030,
    STAT_ST_PERCENTAGE = 1040,
    STAT_ST_ELAP       = 1050,
    STAT_ST_TEMP       = 1060,
    STAT_ST_INNAME     = 2000,
    STAT_ST_INVERTS    = 2010,
    STAT_ST_INPLS      = 2020,
    STAT_ST_TRIVERTS   = 3000,
    STAT_ST_TRIFACES   = 3010,
    STAT_ST_TRIVERTVAL = 3020,
    STAT_ST_TRIFACEVAL = 3030,
    STAT_ST_TEXNAME    = 4000,
    STAT_ST_TEXFACES   = 4010,
    STAT_ST_TEXGEOM    = 4020,
    STAT_ST_TEXMETHOD  = 4030,
    STAT_ST_REDUCVERTS1= 5000,
    STAT_ST_REDUCVERTS2= 5010,
    STAT_ST_REDUCFACES = 5020,
    STAT_ST_REDUCRATE  = 5030,
    STAT_ST_OUTNAME    = 6000,
    STAT_ST_OUTSETS    = 6010,
    STAT_PB_BACKUP     = 7000
} STATWINDLGHANDLES_E;

/*------------------------------------------------------------------------+
|                                                                         |
| Klasse : STATUSWINDOW_C                                                 |
|                                                                         |
+------------------------------------------------------------------------*/

class STATUSWINDOW_C {

// --- Variablen: -----------------------------------------------------

private:

protected:
    HWND      hDlg;
    HBRUSH    hBarBrush;
    HICON     hIcon;
    BOOL      TimerOn;
    long      StartTime;
    float     Elapsed;
    DWORD     LastUpdateTicks;
    BOOL      EnableBackup;

public:
    HISTORYWINDOW_C *HistWinP;

    DWORD     UpdateTicks;

    char      Status [255];
    float     Percentage;
    float     Temperature;
    char      InName [14];
    long      InVerts;
    int       InPls;
    long      TriVerts;
    long      TriFaces;
    long      TriVertsValid;
    long      TriFacesValid;
    char      TexName [14];
    long      TexFaces;
    long      TexSize;
    char      *TexGeom;
    char      *TexMethod;
    long      ReducVerts1;
    long      ReducVerts2;
    long      ReducFaces;
    long      ReducProcessed;
    long      ReducLastSuccess;
    char      OutName [14];
    int       OutSets;


// --- Methoden -------------------------------------------------------

public:                                // Konstruktor, Destruktor
    STATUSWINDOW_C();
    virtual ~STATUSWINDOW_C();

private:

protected:

public:
    HWND    getDlg()                   { return hDlg; }
    HWND    getIcon()                  { return hIcon; }
    BOOL    isOpen()                   { return hDlg!=NULL; }
    BOOL    enableBackup()             { return EnableBackup; }

    // Message server:

    void    updateDlg                  (HWND hDlg);

    // Allgemeine Methoden:

    void    init();

    void    cancelRequest();
    void    status                     (char *Format, ... );
    void    timerReset();
    void    timerStop()                          { TimerOn = FALSE; }
    void    logStatus                  (BOOL FirstTime);

    BOOL    enableBackup               (BOOL OnOff);

    BOOL    openDlg();
    BOOL    closeDlg();
    void    updateDlg();
    HWND    toTop();
    HWND    toBottom();
    BOOL    iconize();
    BOOL    maximize();

}; // class STATUSWINDOW_C

#endif CSTATWIN_HPP
