#ifndef CTEXTURE_HPP
  #define CTEXTURE_HPP

/**************************************************************************
*                                                                         *
* Name   : cTexture.hpp              ( Implementation:                )   *
*                                                                         *
* Klasse(n) definiert : TEXTURE_C                                         *
* Objekt(e) deklariert: -                                                 *
* Abgeleitet von      :                                                   *
*                                                                         *
* Aufgabe :                                                               *
*                                                                         *
**************************************************************************/

// --- Includes: ------------------------------------------------------

#include "cOptions.hpp"

// --- externe Klassen: -----------------------------------------------

class BITMAP_C;

// --- globale Konstanten: --------------------------------------------

// --- globale Typen: -------------------------------------------------


/*------------------------------------------------------------------------+
|                                                                         |
| Klasse : TEXTURE_C                                                      |
|                                                                         |
+------------------------------------------------------------------------*/

class TEXTURE_C {

// --- Variablen: -----------------------------------------------------

private:

protected:
    long      MissCnt;                 // Punkte ausserhalb der Bitmap
    long      Doubles;                 // Anz. der Punkte mit gleichen (U,V) Koordinaten
    long      FaceCnt;

    int       MaxU;
    int       MaxV;
    ISTYPE_E  Surface;
    MAPMETHOD_E Method;
    char      *FName;

    BITMAP_C  *BMP;

public:

// --- Methoden -------------------------------------------------------

public:                                // Konstruktor, Destruktor
    TEXTURE_C();
    virtual ~TEXTURE_C();

private:

protected:

public:
    BOOL      init();                  // benutzt die Einstellungen in Global.OptionsP->..
    BOOL      write();
    BOOL      disposeBM();

    void      xyz2uv            (Ppoint3 &aPoint, int &U, int &V);
    void      setPoint          (int U, int V, Pcobundl &C);
    void      interpolateLinear (int V, Pfloat U1, Pfloat U2, Pcobundl C1, Pcobundl &C2);
    void      paintTri          (int U1, int V1, Pcobundl C1, int U2, int V2, Pcobundl C2,
                                 int U3, int V3, Pcobundl C3);
    void      paintTri2         (int U1, int V1, Pcobundl C1, int U2, int V2, Pcobundl C2,
                                 int U3, int V3, Pcobundl C3);
    void      mapTriangle       (Pptco3 &P1, Pptco3 &P2, Pptco3 &P3);

}; // class TEXTURE_C


#endif CTEXTURE_HPP
