#ifndef CTOOLS_HPP
#define CTOOLS_HPP
/**************************************************************************
*                                                                         *
* Name   : cTools.hpp                  ( Headerdatei:                 )   *
*                                                                         *
* Klasse(n) definiert : -                                                 *
*                                                                         *
* Aufgabe: Sammlung von Hilfsroutinen                                     *
*                                                                         *
* Include Windows.h first !                                               *
*                                                                         *
**************************************************************************/

// --- Includes: ------------------------------------------------------


// --- Debugging: -----------------------------------------------------

BOOL        checkHeapNode (void *P);
BOOL        checkHeap();
BOOL        walkHeap();

// --- Files: ---------------------------------------------------------

long        fileSize         (FILE *stream);
BOOL        fileExist        (char *FSpec);

// --- Files: ---------------------------------------------------------

char*       floatToString    (float F, int Width, int Digits);
BOOL        stringToFloat    (char *S, float *F);

char*       stripZeros       (double F);

// --- Dialogboxen: ---------------------------------------------------

void        vSetDlgItemText  (HWND hDlg, int IdDlgItem, char *Format, ...);

void        newFloatEdit     (HWND hDlg, WORD W, float &F,
                              int Width, int Digits,
                              float Min, float Max);
void        newIntEdit       (HWND hDlg, WORD W, int &I, int Min, int Max);
void        newLongEdit      (HWND hDlg, WORD W, long &L, long Min, long Max);
void        setDlgItemLong   (HWND hDlg, int IdDlgItem, long Value);

// --- Mens: ---------------------------------------------------------

BOOL        enableMenuItem   (HMENU hMenu, int IdDlgItem, BOOL Enable);
BOOL        checkMenuItem    (HMENU hMenu, int IdDlgItem, BOOL Check);
BOOL        toggleMenuItem   (HMENU hMenu, int IdDlgItem, BOOL &Var);

#endif CTOOLS_HPP
