#ifndef CZOFREAD_HPP
  #define CZOFREAD_HPP

/**************************************************************************
*                                                                         *
* Name   :                           ( Implementation:                )   *
*                                                                         *
* Klasse(n) definiert :  ZOFREAD_C                                        *
* Objekt(e) deklariert:                                                   *
*                                                                         *
* Abgeleitet von      :                                                   *
*                                                                         *
* Aufgabe : Einlesen von .ZOF Dateien                                     *
*                                                                         *
**************************************************************************/

// --- Includes: ------------------------------------------------------

#include <stdio.h>


// --- externe Klassen: -----------------------------------------------

class TRISET_C;

// --- globale Konstanten: --------------------------------------------

// --- globale Typen: -------------------------------------------------

/*------------------------------------------------------------------------+
|                                                                         |
| Klasse : ZOFREAD_C                                                      |
|                                                                         |
+------------------------------------------------------------------------*/

class ZOFREAD_C {

// --- Variablen: -----------------------------------------------------

protected:
    char      Str[255];
    FILE      *InFileP;
    long      FileSize;
    long      Line;
    long      BytesRead;

public:
    Pcobundl  DefColour;

// --- Methoden -------------------------------------------------------

public:                                // Konstruktor, Destruktor
    ZOFREAD_C();
    virtual ~ZOFREAD_C();

private:

protected:
    BOOL      searchTriset   (long &NVerts,   long &NFaces,
                              int  &VertFlag, int  &FaceFlag);
    BOOL      open           (char *FSpec);
    void      close();
    void      warning();
    BOOL      readLine       (BOOL Warning = FALSE);

public:
    BOOL      isOpen()           { return (InFileP!=NULL); }

    BOOL      read           (char *FSpec, TRISET_C *TrisetP);

}; // class ZOFREAD_C



#endif CZOFREAD_HPP
