#ifndef CZTYPES_H
#define CZTYPES_H
/***********************************************************************************
*                                                                                  *
*   ZTypes.h                                                                       *
*                                                                                  *
*   Gekrzte Version fr Comp3D                                                    *
*                                                                                  *
************************************************************************************/


/*

    Enviromental Types       

*/

// 'float' fr 4-Byte Version:

typedef	float           Pfloat;         /* FLOATing point format */

typedef	int		Pint;           /* INTeger format */
typedef	unsigned int	Puint;          /* UNSIGNED INTeger format */
typedef	long int	Plong;          /* LONG integer format */
typedef	char		Pchar;          /* CHARacter format */
typedef	char		Pfile[];        /* FILEname */

typedef	char		Pbool;          /* BOOLean format (*) */
typedef long int        Psize;          /* size_t type */
#ifndef TRUE
#define TRUE		1               /* for use with Pbool (*) */
#define FALSE		0               /* for use with Pbool (*) */
#endif

#ifndef NULL
#define NULL 0L
#endif
/*

    Z-Phigs System Types     

*/
typedef	Pfloat		*Ppfloat; /* Pointer to PFLOAT */
typedef	Pint		*Ppint; /* Pointer to PINT */
typedef	unsigned char	Penumch;/* ENUM in CHar size */

typedef	struct {
	Pfloat		x, y, z;
} Ppoint3; /* POINT 3 */
typedef	Pfloat	Pmatrix3[4][4]; /* MATRIX 3 */

typedef unsigned char   Pbyte;
typedef struct {
	Pbyte		x, y, z;
} Pbyte3;/* 3 bites */

typedef	struct {
	Pfloat		u,v;
} Pxparameter;/* Parameters */



typedef	struct {
	Pfloat	x,y,z; /* rgb or hls or hvs colour values */
} Pcobundl;/* COlour BUNDLe */





typedef	struct {
	Pint		size;    /* size of data    */
	Pchar		*data;   /* pointer to data */
} Pdata; /* DATA */

typedef	struct {
	Pint		xmin, xmax, ymin, ymax;
} Pilimit; /* Integer LIMIT */

typedef	struct {
	Pint		xmin, xmax, ymin, ymax, zmin, zmax;
} Pilimit3; /* Integer LIMIT 3 */

typedef	struct {
	Pint		x, y;
} Pipoint; /* Integer POINT */

typedef	struct {
	Pint		x, y, z;
} Pipoint3; /* Integer POINT 3 */



typedef	struct {
	Pfloat		xmin, xmax, ymin, ymax;
} Plimit; /* LIMIT */

typedef	struct {
	Pfloat		xmin, xmax, ymin, ymax, zmin, zmax;
} Plimit3; /* LIMIT 3 */

typedef	Pfloat	Pmatrix[3][3]; /* MATRIX */



typedef	struct {
	Pfloat		x, y;
} Ppoint; /* POINT */

typedef struct {
        Ppoint3  fll;     /* front lower left */
        Ppoint3  bur;     /* back upper right */
} Prect3;/* RECTangle 3 */

typedef struct {
	Ppoint		ll;  /* lower left  */
	Ppoint		ur;  /* upper right */
} Prect; /* RECTangle */

typedef Ppoint Pvector; /* VECTOR */
typedef Ppoint3 Pvector3; /* VECTOR 3 */



#define PSH_NONE           1 /* flat shading        */
#define PSH_COLOUR         2 /* Gouraud shading     */
#define PSH_DOT            3 /* cheap Phong shading */
#define PSH_NORMAL         4 /* Phong shading       */

#define PLNSH_NONE         1 /* constant colour     */
#define PLNSH_COLOUR       2 /* interpolated colour */

#define PVERT_NONE         1 /* coordinates only                */
#define PVERT_COLOUR       2 /* coordinates and colours         */
#define PVERT_NORMAL       3 /* coordinates and normals         */
#define PVERT_DATA         4 /* coordinates and data            */
#define PVERT_COLOURNORMAL 5 /* coordinates,colours and normals */
#define PVERT_COLOURDATA   6 /* coordinates,colours and data    */
#define PVERT_NORMALDATA   7 /* coordinates,normals and data    */
#define PVERT_COLOURNORMALDATA 8 /* coords.,normals and data    */

#define PFA_NONE             1 /* nothing             */
#define PFA_COLOUR           2 /* colours             */
#define PFA_NORMAL           3 /* normals             */
#define PFA_DATA             4 /* data                */
#define PFA_COLOURNORMAL     5 /* colours and normals */
#define PFA_COLOURDATA       6 /* colours and data    */
#define PFA_NORMALDATA       7 /* normals and data    */
#define PFA_COLOURNORMALDATA 8 /* normals and data    */

#define PED_NONE	1 /* nothing               */
#define PED_EDGEFLAGS	2 /* edge visibility flags */


/* Data Mapping Methods */

#define PDATAMAP_TEXTURE         -1  /* implementation specific */
#define PDATAMAP_INDEX            0  /* implementation specific */
#define PDATAMAP_COLOUR           1
#define PDATAMAP_SINGLE_UNI       2
#define PDATAMAP_SINGLE_NONUNI    3
#define PDATAMAP_BI_UNI           4
#define PDATAMAP_BI_NONUNI        5


#define PSRC_COLOUR_ASPECT  1 /* source selector list flags */
#define PSRC_VERTEX_COLOUR  2
#define PSRC_VERTEX_DATA    3
#define PSRC_FACET_COLOUR   4
#define PSRC_FACET_DATA     5



typedef struct {
	Ppoint3   point;
	Pcobundl  colour;
} Pptco3;/* point and colour (+) */

typedef struct {
	Ppoint3   point;
	Pvector3  normal;
} Pptnorm3;/* point and normal (+) */

typedef struct {
	Ppoint3   point;
	Pcobundl  colour;
	Pvector3  normal;
} Pptconorm3;/* point, colour and normal (+) */



typedef struct {
	Pcobundl  colour;
	Pvector3  normal;
} Pconorm3;/* colour and normal (+) */


/*

    EGA Colours              

*/
typedef enum {
	PEGA_BLACK,	/* EGA default BLACK          (*) */
	PEGA_DBLUE,	/* EGA default DARK BLUE      (*) */
	PEGA_DGREEN,	/* EGA default DARK GREEN     (*) */
	PEGA_DCYAN,	/* EGA default DARK CYAN      (*) */
	PEGA_DRED,	/* EGA default DARK RED       (*) */
	PEGA_DMAGENTA,	/* EGA default DARK MAGENTA   (*) */
	PEGA_DYELLOW,	/* EGA default DARK YELLOW    (*) */
	PEGA_GREY,	/* EGA default GREY           (*) */
	PEGA_COAL,	/* EGA default BLACK          (*) */
	PEGA_BBLUE,	/* EGA default BRIGHT BLUE    (*) */
	PEGA_BGREEN,	/* EGA default BRIGHT GREEN   (*) */
	PEGA_BCYAN,	/* EGA default BRIGHT CYAN    (*) */
	PEGA_BRED,	/* EGA default BRIGHT RED     (*) */
	PEGA_BMAGENTA,	/* EGA default BRIGHT MAGENTA (*) */
	PEGA_BYELLOW,	/* EGA default BRIGHT YELLOW  (*) */
	PEGA_WHITE,	/* EGA default WHITE          (*) */
} Pxegacolour;/* EGA default colours (*) */
/*

    Misc    Stuff            

*/

#define PLN_SOLID	1  /* SOLID LiNe type    */
#define PLN_DASH	2  /* DASHed LiNe type   */
#define PLN_DOT		3  /* DOTted LiNe type   */
#define PLN_DOTDASH	4  /* DOT-DASH LiNe type */

#define PMK_POINT	1  /* MarKer is a single pixel POINT */
#define PMK_PLUS	2  /* MarKer is a PLUS sign          */
#define PMK_STAR	3  /* MarKer is a STAR sign          */
#define PMK_O		4  /* MarKer is an O (circle)        */
#define PMK_X		5  /* MarKer is an X (cross)         */

#define PAN_UNCON	1  /* ANnnotation text pts UNCONnected */
#define PAN_LEADLINE	2  /* ANn. pts connected with LEADLINE */

#define PDEFAULT_MEM_SIZE 1 /* phigs DEFAULT MEMory SIZE */


#endif CZTYPES_H
