/**************************************************************************
*                                                                         *
* Name   : cGlue.cpp                ( Headerdatei:                 )      *
*                                                                         *
* Klasse(n) definiert : GLUE_C                                            *
* Objekt(e) deklariert: -                                                 *
*                                                                         *
* Abgeleitet von      : -                                                 *
*                                                                         *
* Aufgabe:                                                                *
*                                                                         *
**************************************************************************/

// --- Includes: ------------------------------------------------------

#include "cTypes.hpp"

#include <mem.h>

#include "cGlue.hpp"


// --- lokale Konstanten:----------------------------------------------

// --- lokale Typen: --------------------------------------------------

// --- lokale Variablen: ----------------------------------------------


/*------------------------------------------------------------------------+
|                                                                         |
| lokale Funktionen                                                       |
|                                                                         |
+------------------------------------------------------------------------*/

/*------------------------------------------------------------------------+
|                                                                         |
| Methoden der Klasse GLUE_C                                              |
|                                                                         |
+------------------------------------------------------------------------*/

GLUE_C::GLUE_C()
{
    NGlues=0;
    memset (GlueTab, 0, MaxGlues * sizeof (GLUE_S) );
}

GLUE_C::~GLUE_C()
{
//  if (NGlues) printf ("GlueTab hat noch %d Eintrge!\n", NGlues);
}

BOOL GLUE_C::addGlue (HWND aWnd, void* aThis)
{
    if (NGlues>=MaxGlues) return FALSE;

    GlueTab [NGlues].Wnd   = aWnd;
    GlueTab [NGlues].ThisP = aThis;
    NGlues++;

    return TRUE;
}

BOOL GLUE_C::delGlue (HWND aWnd)
{
    int N=0;

    while ( (N<NGlues) && (GlueTab [N].Wnd!=aWnd) ) N++;

    if (N==NGlues) return FALSE;

    for (int I=N; I<NGlues; I++) GlueTab [I]=GlueTab [I+1];

    NGlues--;

    GlueTab [NGlues].Wnd   = NULL;
    GlueTab [NGlues].ThisP = NULL;

    return TRUE;
}

BOOL GLUE_C::delGlue (void* aThis)
{
    int N=0;

    while ( (N<NGlues) && (GlueTab [N].ThisP!=aThis) ) N++;

    if (N==NGlues) return FALSE;

    for (int I=N; I<NGlues; I++) GlueTab [I]=GlueTab [I+1];

    NGlues--;

    GlueTab [NGlues].Wnd   = NULL;
    GlueTab [NGlues].ThisP = NULL;

    return TRUE;
}

HWND GLUE_C::getWndFromThis (void* aThis)
{
    int N = 0;

    while ( (N<NGlues) && (GlueTab [N].ThisP!=aThis) ) N++;

    return ( N==NGlues ? 0 : GlueTab [N].Wnd );
}

void* GLUE_C::getThisFromWnd (HWND aWnd)
{
    int N = 0;

    while ( (N<NGlues) && (GlueTab [N].Wnd!=aWnd) ) N++;

    return ( N==NGlues ? NULL : GlueTab [N].ThisP );
}
