/**************************************************************************
*                                                                         *
* Name    : cMainWnd.cpp                                                  *
*                                                                         *
* Aufgabe :                                                               *
*                                                                         *
**************************************************************************/

// --- Includes: ------------------------------------------------------

#include "cTypes.hpp"

#include <conio.h>
#include <string.h>

#include "cGlobal.hpp"
#include "cGlue.hpp"
#include "\src\lib\crtio.h"

#include "cMainWin.hpp"
#include "cCefRead.hpp"
#include "cOptions.hpp"
#include "cPolyLin.hpp"
#include "cReduce.hpp"
#include "cStatWin.hpp"
#include "cTexture.hpp"
#include "cTriset.hpp"
#include "cGeomOut.hpp"
#include "cTools.hpp"
#include "cZofRead.hpp"

// --- lokale Konstanten:----------------------------------------------

// --- lokale Typen: --------------------------------------------------


// --- lokale Variablen: ----------------------------------------------


/*------------------------------------------------------------------------+
|                                                                         |
| lokale Funktionen                                                       |
|                                                                         |
+------------------------------------------------------------------------*/

/*------------------------------------------------------------------------+
|                                                                         |
| About Dialogbox Messagehandler                                          |
|                                                                         |
+------------------------------------------------------------------------*/

BOOL FAR PASCAL _export aboutDlgProc (HWND hDlg, WORD Message, WORD wParam, LONG lParam)
{
    switch (Message) {

        case WM_INITDIALOG:
            SetDlgItemText  (hDlg, ABOUT_ST_VERSION, VERSIONSTRING);
            vSetDlgItemText (hDlg, ABOUT_ST_DATE, "%s at %s",
                             (LPSTR) __DATE__, (LPSTR) __TIME__);
           break;

        case WM_COMMAND:

            switch ( wParam ) {
                case IDOK:
                case IDCANCEL:
                    if (HIWORD(lParam) == BN_CLICKED)
                       EndDialog(hDlg, wParam);
                    break;
                default:
                    return TRUE;
            }
            break;
    default:
        return FALSE;
    }
    return TRUE;
}

/*------------------------------------------------------------------------+
|                                                                         |
| Main Window Messagehandler                                              |
|                                                                         |
+------------------------------------------------------------------------*/

long  FAR PASCAL _export mainWndProc (HWND hWnd, UINT Message, UINT wParam, LONG lParam)
{
    MAINWINDOW_C *P;

    if (Message==WM_CREATE)
        Global.GlueP->addGlue (hWnd, ((CREATESTRUCT*)lParam)->lpCreateParams);

    P = (MAINWINDOW_C*) Global.GlueP->getThisFromWnd (hWnd);

    if (!P) return DefWindowProc (hWnd, Message, wParam, lParam);

    OPTIONS_C    *OptsP  = Global.OptionsP;

    switch (Message) {

        case WM_CLOSE:
            if (OptsP)
                OptsP->CrtioIconic = IsIconic (getcrtiowindow());
            // fall through

        case WM_QUERYENDSESSION:

            BOOL OkToQuit = TRUE;

            if ( Global.busy() ) {

                OkToQuit = MessageBox (GetFocus(), "Ok to terminate ?",
                                       "Comp3D",
                                       MB_ICONQUESTION | MB_YESNO |
                                       MB_DEFBUTTON2)
                          == IDYES;
            }
            if (OkToQuit)
                if (Message==WM_CLOSE)
                    DestroyWindow (hWnd);
                else
                    return TRUE;
            break;

        case WM_DESTROY:
            Global.GlueP->delGlue (hWnd);
            PostQuitMessage(0);
            break;

        case WM_COMPACTING:
            Global.wmCompacting (wParam);
            break;

        case WM_MOUSEMOVE:
            SetCursor (LoadCursor (NULL, Global.waiting() ? IDC_WAIT : IDC_ARROW));
            break;

        case WM_COMMAND:

            HANDLE       hInst   = Global.getInstance();
            HMENU        hMenu   = GetMenu (hWnd);
            MAINMENUID_E Cmd     = (MAINMENUID_E) wParam;

            switch (Cmd) {

                case MAIN_CONVREDUC:
                    if (OptsP)
                        if ( OptsP->execConvReducDlg(hWnd) )
                            P->comp3dMain();
                    break;

                case MAIN_EXIT:
                    SendMessage (hWnd, WM_CLOSE, 0, 0L);
                    break;

                case MAIN_OPTSINPUT:
                    Global.info ("not available");
                    break;

                case MAIN_OPTSFILTER:
                    if (OptsP) OptsP->execFilterDlg(hWnd);
                    break;
                case MAIN_OPTSREDUCPL:
                    if (OptsP) OptsP->execReducePLDlg(hWnd);
                    break;
                case MAIN_OPTSREDUCTRI:
                    if (OptsP) OptsP->execReduceTriDlg(hWnd);
                    break;
                case MAIN_OPTSTEXTURE:
                    if (OptsP) OptsP->execTextureDlg(hWnd);
                    break;
                case MAIN_OPTSOUTPUT:
                    if (OptsP) OptsP->execOutputDlg(hWnd);
                    break;
                case MAIN_OPTSHISTORY:
                    if (OptsP)
                        toggleMenuItem (hMenu, Cmd, OptsP->HistoryGraph);
                    break;
                case MAIN_DBGLOGCEF:
                    if (OptsP)
                        toggleMenuItem (hMenu, Cmd, OptsP->LogCefRead);
                    break;
                case MAIN_DBGLOGSETTNG:
                    if (OptsP)
                        toggleMenuItem (hMenu, Cmd, OptsP->LogSettings);
                    break;
                case MAIN_DBGLOGHISTORY:
                    if (OptsP)
                        toggleMenuItem (hMenu, Cmd, OptsP->LogHistory);
                    break;
                case MAIN_DBGMORE:
                    if (OptsP) OptsP->execDebugDlg(hWnd);
                    break;

                case MAIN_ABOUT:
                    DialogBox (hInst, "DLG_ABOUT", hWnd,
                               MakeProcInstance ((FARPROC)aboutDlgProc, hInst));
                    break;
                default:
                    return DefWindowProc (hWnd, Message, wParam, lParam);
            }
            break;
	default:
	    return DefWindowProc (hWnd, Message, wParam, lParam);
    }
    return 0; // Message processed
}

/*------------------------------------------------------------------------+
|                                                                         |
| Window Initialisierung                                                  |
|                                                                         |
+------------------------------------------------------------------------*/

int MAINWINDOW_C::registerWindow (HANDLE hInstance)
{
    WNDCLASS  WndClass;

    WndClass.style         = NULL;
    WndClass.lpfnWndProc   = mainWndProc;
    WndClass.cbClsExtra    = 0;
    WndClass.cbWndExtra    = 0;
    WndClass.hInstance     = hInstance;
    WndClass.hIcon         = LoadIcon (hInstance, "ICO_COMP3D");
    WndClass.hCursor       = NULL; // LoadCursor(NULL, IDC_ARROW);
    WndClass.hbrBackground = GetStockObject (LTGRAY_BRUSH);
    WndClass.lpszMenuName  = "MNU_MAIN";
    WndClass.lpszClassName = COMP3DCLASSNAME;

    return (RegisterClass(&WndClass));
}

HWND MAINWINDOW_C::createWindow (HANDLE  hInstance, int CmdShow)
{
    HWND  hWnd;

    char *Title = "Comp3D";
    long Style  = WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN;

    hWnd = CreateWindow(
	COMP3DCLASSNAME,                      // Class name
        Title,
        Style,
	CW_USEDEFAULT, CW_USEDEFAULT,         // Window position
        CW_USEDEFAULT, CW_USEDEFAULT,         // Window size
	NULL,                                 // Parent window handle
	NULL,                                 // use class menu
	hInstance,                            // Task handle
	(LPSTR)this                           // passed in lParam of WM_CREATE message
    );

    if (!hWnd) return 0;

    ShowWindow   (hWnd, CmdShow);
    UpdateWindow (hWnd);
    return hWnd;
}

/*------------------------------------------------------------------------+
|                                                                         |
| Main window                                                             |
|                                                                         |
+------------------------------------------------------------------------*/


MAINWINDOW_C::MAINWINDOW_C()
{
    hWnd = NULL;
}

MAINWINDOW_C::~MAINWINDOW_C()
{
}

BOOL MAINWINDOW_C::openWnd (int cmdShow)
{
    if (!registerWindow (Global.getInstance()))
        return FALSE;

    hWnd = createWindow (Global.getInstance(), cmdShow);
    if (!hWnd) return FALSE;

    // CrtIO Window initialisieren:

    setcrtiomother (hWnd);
    textcolor (12);

    printf ("%s\n\n", VERSIONSTRING);

    SetWindowText (getcrtiowindow(), "Output");

    return TRUE;
}

BOOL MAINWINDOW_C::updateMenu()
{
    OPTIONS_C *OP = Global.OptionsP;

    if (!OP) return FALSE;

    HMENU  hMenu   = GetMenu (hWnd);

    // Disablen, wenn busy (PopUps's knnen nur by Position angefat werden)

    BOOL  Busy = Global.busy();

    enableMenuItem (hMenu, MAIN_CONVREDUC, !Busy);

    EnableMenuItem (hMenu, MAIN_POS_OPTIONS,
                           MF_BYPOSITION | ( Busy ? MF_GRAYED : MF_ENABLED ));
    EnableMenuItem (hMenu, MAIN_POS_DEBUG,
                           MF_BYPOSITION | ( Busy ? MF_GRAYED : MF_ENABLED ));

    // Checkmarker setzen:

    checkMenuItem (hMenu, MAIN_OPTSHISTORY,   OP->HistoryGraph);
    checkMenuItem (hMenu, MAIN_DBGLOGCEF,     OP->LogCefRead);
    checkMenuItem (hMenu, MAIN_DBGLOGSETTNG,  OP->LogSettings);
    checkMenuItem (hMenu, MAIN_DBGLOGHISTORY, OP->LogHistory);

    // Anzeigen:

    DrawMenuBar (hWnd);

    return TRUE;
}

/*------------------------------------------------------------------------+
|                                                                         |
| Comp3d : Einlesen, Konvertieren, Reduzieren                             |
|                                                                         |
+------------------------------------------------------------------------*/

BOOL MAINWINDOW_C::comp3dMain()
{
    VERTEXARRAY_C *PlP1, *PlP2, *TempPlP;
    VERTEXARRAY_C *FirstPLP;
    VERTEXARRAY_C *PolyLine1P;
    VERTEXARRAY_C *PolyLine2P;

    //---------------------------------------------------------------
    // Initialisierungen
    //---------------------------------------------------------------

    if ( strlen (Global.OptionsP->InFile)==0 )
        return FALSE;

    BOOL            Status = TRUE;

    CEFREAD_C*      CefP   = Global.CefReadP;
    OPTIONS_C*      OptsP  = Global.OptionsP;
    REDUCE_C*       RedcP  = Global.ReduceP;
    STATUSWINDOW_C* StatP  = Global.StatWinP;
    TRISET_C*       TrisP  = Global.TrisetP;

    StatP->status ("initializing ...");

    Global.setBusy();
    Global.wait();

    updateMenu();

    Global.reInit();

    OptsP->logSettings();

    StatP->maximize();

    StatP->status ("");

    StatP->timerReset();

    TrisP->createVertHashTab (OptsP->VertHashTabSize);

    //---------------------------------------------------------------
    // Zof-Datei: Triset direkt einlesen
    //---------------------------------------------------------------

    if (strstr (strupr (OptsP->InFile), ".ZOF") ) {

        ZOFREAD_C *ZofReadP = new ZOFREAD_C;
        if (!ZofReadP) goto NotAusgang;

        if ( !ZofReadP->read (OptsP->InFile, TrisP) ) {

            Status = FALSE;
            goto NotAusgang;
        }

        delete ZofReadP;

        goto SkipReading;
    }

    //---------------------------------------------------------------
    // Cef-Datei: einlesen
    //---------------------------------------------------------------

    if ( CefP->open (OptsP->InFile, OptsP->LogCefRead) != CEF_OK ) {

        Status = FALSE;
        goto NotAusgang;
    }

    FirstPLP   = new VERTEXARRAY_C (1, 1);
    PolyLine1P = new VERTEXARRAY_C (1000, 100);
    PolyLine2P = new VERTEXARRAY_C (1000, 100);

    // Fr alle Polylines: einlesen, Texturemapping, ReducePL, Triset erzeugen

    CefP->readNextPL (PolyLine1P);

    PlP1 = PolyLine1P;
    PlP2 = PolyLine2P;

    do {
        if ( ! CefP->readNextPL (PlP2) ) {

            break;
        }

        if (OptsP->TextureMapping) {

            TrisP->MapTriangles   = TRUE;
            TrisP->StoreTriangles = FALSE;
            TrisP->addStripToTriset (*PlP1, *PlP2);
        }

        if (CefP->EdgeCnt==2) {

            RedcP->reducePL (*PlP1);
            if (OptsP->CloseObject) FirstPLP->copyFrom (PlP1);
        }
        RedcP->reducePL (*PlP2);

        TrisP->MapTriangles   = FALSE;
        TrisP->StoreTriangles = TRUE;
        TrisP->addStripToTriset (*PlP1, *PlP2);

        StatP->updateDlg();

        PlP1->clear();
        TempPlP=PlP1; PlP1=PlP2; PlP2=TempPlP;

    } while ( ! Global.CancelRequest );

    CefP->close();

    if (OptsP->CloseObject) {

        if (OptsP->TextureMapping) {

            TrisP->MapTriangles   = TRUE;
            TrisP->StoreTriangles = FALSE;
            TrisP->addStripToTriset (*PlP1, *FirstPLP);
        }
        TrisP->MapTriangles   = FALSE;
        TrisP->StoreTriangles = TRUE;
        TrisP->addStripToTriset (*PlP1, *FirstPLP);

        StatP->updateDlg();
    }

    if (FirstPLP)   delete FirstPLP;
    if (PolyLine1P) delete PolyLine1P;
    if (PolyLine2P) delete PolyLine2P;

    //---------------------------------------------------------------
    // Speicher aufrumen
    //---------------------------------------------------------------

SkipReading:

    TrisP->destroyVertHashTab();

    if (Global.CancelRequest) {

        Status = FALSE;
        Global.TextureP->disposeBM();
        goto NotAusgang;
    }

    Global.TextureP->write();
    Global.TextureP->disposeBM();

    StatP->logStatus (TRUE);

    //---------------------------------------------------------------
    // ggf. mu geprft werden, ob die Faces des Triset gleichmig
    // orientiert sind. Wenn nicht, ist AvoidDoubles fragwrdig
    //---------------------------------------------------------------

    if (OptsP->AvoidDoubles) {

        if (!TrisP->isEqualOrientated()) {

            int A = MessageBox (NULL, "Triset is not equal orientated.\n"
                                      "AvoidDoubles may not work\n"
                                      "Yet avoid doubles ?",
                                      "CONFIRM",
                                      MB_YESNO | MB_ICONQUESTION
                               );
            if (A==IDNO) OptsP->AvoidDoubles = FALSE;
        }
    }

    //---------------------------------------------------------------
    // Triset reduzieren
    //---------------------------------------------------------------

    RedcP->reduceTriset();

    StatP->logStatus (FALSE);

    //---------------------------------------------------------------
    // Triset schreiben
    //---------------------------------------------------------------

    StatP->enableBackup (TRUE);
    TrisP->backup();                   // fragt nach, wenn Energie schlechter wrde
    StatP->enableBackup (FALSE);

    StatP->timerStop();
    StatP->Percentage = 100.0;
    StatP->status ("Done.");
    StatP->updateDlg();

NotAusgang:

    StatP->iconize();

    Global.CancelRequest = FALSE;
    Global.clearBusy();
    Global.noWait();

    updateMenu();

    return Status;
}

