/**************************************************************************
*                                                                         *
* Name   : cTest.cpp                   ( Headerdatei: ---             )   *
*                                                                         *
* Klasse(n) definiert : -                                                 *
*                                                                         *
* Aufgabe: Testroutinen (wird von nur cComp3D.cpp benutzt).               *
*          Nicht in die Projektdatei aufnehmen!                           *
*                                                                         *
**************************************************************************/

// --- Includes: ------------------------------------------------------

#include <string.h>

//#include "cGlobal.hpp"
#include "cMath.hpp"
#include "cStatWin.hpp"
#include "cTexture.hpp"

// --- lokale Konstanten:----------------------------------------------

// --- lokale Typen: --------------------------------------------------

// --- lokale Variablen: ----------------------------------------------


/*------------------------------------------------------------------------+
|                                                                         |
| Testroutinen:                                                           |
|                                                                         |
+------------------------------------------------------------------------*/

void testTriangleColor()
{
    int       NTris = 1;
    Pcobundl  Red   = { 1.0, 0.0, 0.0 };
    Pcobundl  Green = { 0.0, 1.0, 0.0 };
    Pcobundl  Blue  = { 0.0, 0.0, 1.0 };

    Global.StatWinP->openDlg();

    Global.wait();

    Global.OptionsP->U = 240;
    Global.OptionsP->V = 240;
    strcpy (Global.OptionsP->TexFile, "\\src\\diplom\\test.bmp");

    Global.TextureP->init();

    Global.StatWinP->status ("testing triangle color interpolation ...");

    Global.StatWinP->timerReset();    

    for (int I=0; I<NTris; I++) {

        // Rechtwinklig in der Ecke: (4 * 1250 Pkte)

        Global.TextureP->paintTri2 (   1, 200, Red,  50, 200, Green,   1, 150, Blue);
        Global.TextureP->paintTri2 ( 150, 200, Red, 200, 200, Green, 200, 150, Blue);
        Global.TextureP->paintTri2 (   1,  50, Red,   1,   1, Green,  50,   1, Blue);
        Global.TextureP->paintTri2 ( 150,   1, Red, 200,   1, Green, 200,  50, Blue);

        // P2 links von P1:

        Global.TextureP->paintTri2 (   1, 101, Red,  30, 150, Green,  60, 130, Blue);
        Global.TextureP->paintTri2 (  70, 150, Red, 100, 101, Green, 120, 130, Blue);
        Global.TextureP->paintTri2 ( 130, 150, Red, 180, 130, Green, 200, 101, Blue);

        // P2 rechts von P1:

        Global.TextureP->paintTri2 (   1,  80, Red,  30, 100, Green,  60,  50, Blue);
        Global.TextureP->paintTri2 (  70,  80, Red, 100,  50, Green, 120, 100, Blue);
        Global.TextureP->paintTri2 ( 130,  50, Red, 150,  80, Green, 200, 100, Blue);
    }
    long NPts = 10000L * NTris;

    Global.StatWinP->timerStop();
    Global.StatWinP->Percentage = 100;
    Global.StatWinP->status ("");
    Global.StatWinP->updateDlg();

    if ( ! Global.CancelRequest )
        Global.TextureP->write();

    Global.noWait();

    Global.StatWinP->status ("Done.");

    Global.CancelRequest = FALSE;
}

void testMath()
{
    int       NRun = 1;

    #define Z 1.0

    Ppoint3 A  = { 2.0, 2.0, 0.0};
    Ppoint3 B  = { 4.0, 6.0, 0.0};
    Ppoint3 C  = { 6.0, 4.0, 0.0};

    Ppoint3 P1 = { 1.0, 1.0, Z};
    Ppoint3 P2 = { 5.0, 2.0, Z};
    Ppoint3 P3 = { 8.0, 4.0, Z};
    Ppoint3 P4 = { 6.0, 6.0, Z};
    Ppoint3 P5 = { 4.0, 7.0, Z};
    Ppoint3 P6 = { 2.0, 5.0, Z};
    Ppoint3 P7 = { 4.0, 4.0, Z};
    Ppoint3 P8 = { 4.0, 3.0, Z};
    Ppoint3 P9 = { 5.0, 5.0, Z};
    Ppoint3 P10= { 3.0, 4.0, Z};

    Global.StatWinP->openDlg();

    Global.wait();

    Global.StatWinP->status ("testing math routines ...");

    Global.StatWinP->timerReset();

    Pfloat D1, D2;

    for (int I=0; I<NRun; I++) {

//      D1 = volumeTetra (P1, P2, P3, P4);
//      D2 = volumeTetra (P1, P2, P3, P5);

//      D1 = distancePtTri3 (P1, P2, P3, P4);
//      D2 = distancePtPlane3 (P1, P2, P3, P4);

        Global.debugMsg ("P1: %f\n", distancePtTri3 (P1, A, B, C));
        Global.debugMsg ("P2: %f\n", distancePtTri3 (P2, A, B, C));
        Global.debugMsg ("P3: %f\n", distancePtTri3 (P3, A, B, C));
        Global.debugMsg ("P4: %f\n", distancePtTri3 (P4, A, B, C));
        Global.debugMsg ("P5: %f\n", distancePtTri3 (P5, A, B, C));
        Global.debugMsg ("P6: %f\n", distancePtTri3 (P6, A, B, C));
        Global.debugMsg ("P7: %f\n", distancePtTri3 (P7, A, B, C));
        Global.debugMsg ("P8: %f\n", distancePtTri3 (P8, A, B, C));
        Global.debugMsg ("P9: %f\n", distancePtTri3 (P9, A, B, C));
        Global.debugMsg ("P10:%f\n", distancePtTri3 (P10, A, B, C));
    }

    Global.StatWinP->timerStop();
    Global.StatWinP->Percentage = 100;
    Global.StatWinP->status ("");
    Global.StatWinP->updateDlg();

    Global.noWait();

    Global.StatWinP->status ("Done.");

//  Global.info ("d1: %lf, d2: %lf, %0.2f secs, %0.4f secs/run", D1, D2, Elap, Elap/NRun);

    Global.CancelRequest = FALSE;
}

